from django.shortcuts import render, get_object_or_404
from django.http import HttpResponse, Http404
from .models import *
from django.core.exceptions import ObjectDoesNotExist
from django.http import JsonResponse
from django.views.decorators.csrf import csrf_exempt
import os
from django.db.utils import ProgrammingError
import datetime
from django.shortcuts import redirect
from django.core.exceptions import ValidationError
import json
from django.views import generic
from django.db.models.aggregates import Count
from django.db.models import Count
# Create your views here.


def index(request):
    user_list = User.objects.filter(isCurrent=1, identity='0').all()
    user_type_list = {"Academic STAFF": [], "Phd": [], "Master": [], "Engineer STAFF": []}
    for u in user_list:
        if u.member_type == 0:
            u.member_type = "Academic STAFF"
        else:
            if u.member_type == 1:
                u.member_type = "Engineer STAFF"
            else:
                if u.member_type == 2:
                    u.member_type = "Phd"
                else:
                    u.member_type = "Master"
        member_type = u.member_type
        if member_type in user_type_list.keys():
            user_type_list[member_type].append(u)
        else:
            user_type_list[member_type] = [u]

    user_list_former = User.objects.filter(isCurrent=0, identity='0').all()
    user_type_list_former = {"Academic STAFF": [], "Phd": [], "Master": [], "Engineer STAFF": []}
    for u in user_list_former:
        if u.member_type == 0:
            u.member_type = "Academic STAFF"
        else:
            if u.member_type == 1:
                u.member_type = "Engineer STAFF"
            else:
                if u.member_type == 2:
                    u.member_type = "Phd"
                else:
                    u.member_type = "Master"
        member_type = u.member_type
        if member_type in user_type_list.keys():
            user_type_list_former[member_type].append(u)
        else:
            user_type_list_former[member_type] = [u]

    publication_list = Publications.objects.order_by('-date')
    publication_year_list = {}
    for pub in publication_list:
        year = str(pub.date)[0:4]
        pub.date = str(pub.date)[5:10]
        pub.link = pub.link.split('/')[-1]
        print(pub.link)
        if year in publication_year_list.keys():
            publication_year_list[year].append(pub)
        else:
            publication_year_list[year] = [pub]

    bug_list = Bugs.objects.order_by('-datetime')
    cve_year_list = {}
    for cve in bug_list:
        year = str(cve.datetime)[0:4]
        cve.datetime = str(cve.datetime)[5:10]
        print(cve.datetime)
        if year in cve_year_list.keys():
            cve_year_list[year].append(cve)
        else:
            cve_year_list[year] = [cve]

    article_list = Articles.objects.order_by('-editDateTime')
    article_year_list = {}
    for art in article_list:
        year = str(art.editDateTime)[0:4]
        art.editDateTime = str(art.editDateTime)[5:10]
        u = User.objects.filter(userID=art.authorID).values('name')
        art.authorID = u[0]['name']
        if year in article_year_list.keys():
            article_year_list[year].append(art)
        else:
            article_year_list[year] = [art]

    newest_post_list = {}
    start = datetime.datetime.now().date()-datetime.timedelta(hours=23*7, minutes=59, seconds=59)
    newest_publication = Publications.objects.filter(date__gte=start).order_by('-date')
    for pub in newest_publication:
        pub.author = pub.uploadByUser
        pub.url = '/static/hunter/publications/'+pub.link
        pub.date = str(pub.date)[5:10]
    newest_article = Articles.objects.filter(editDateTime__gte=start).order_by('-editDateTime')
    for art in newest_article:
        users = User.objects.filter(userID=art.authorID).values('name')
        art.author = users[0]['name']
        art.url = '/article/'+str(art.articleID)
        art.date = str(art.editDateTime)[5:10]

    newest_cve = Bugs.objects.filter(datetime__gte=start).order_by('-datetime')
    for cve in newest_cve:
        cve.title = cve.identifier
        cve.author = cve.owner
        cve.date = str(cve.datetime)[5:10]

    newest_post_list['publication'] = newest_publication
    newest_post_list['article'] = newest_article
    newest_post_list['cve'] = newest_cve
    context = {
        'user_type_list': user_type_list,
        'user_type_list_former': user_type_list_former,
        'publication_year_list': publication_year_list,
        'cve_year_list': cve_year_list,
        'article_year_list': article_year_list,
        'newest_post_list': newest_post_list,
    }
    return render(request, 'hunter/index.html', context)


@csrf_exempt
def login(request):
    username = request.POST['username']
    password = request.POST['password']
    user_id=""
    try:
        db_info = User.objects.get(name=username)
    except ObjectDoesNotExist as e:
        response = JsonResponse({"message": "用户不存在"})
        return response
    else:
        if db_info.pwd == password:
            user_id = db_info.userID
            response = JsonResponse({"message": "success", "userid": user_id})
        else:
            response = JsonResponse({"message": "密码错误"})
    return response


def user(request, user_id):
    usr = get_object_or_404(User, pk=user_id)
    print(usr.name)
    username = usr.name
    u = {'userID': user_id, 'name': username}
    my_publication_year_list = {}
    pub_ids = PubToUser.objects.filter(username=username).all().values("pubID")
    for pub_id in pub_ids:
        print(pub_id)
        pub = get_object_or_404(Publications, pk=pub_id['pubID'])
        year = str(pub.date)[0:4]
        pub.date = str(pub.date)[5:10]
        pub.link = pub.link.split('/')[-1]
        if year in my_publication_year_list.keys():
            my_publication_year_list[year].append(pub)
        else:
            my_publication_year_list[year] = [pub]

    my_article_list = Articles.objects.filter(authorID=user_id).order_by('-editDateTime')
    my_article_year_list = {}
    for art in my_article_list:
        year = str(art.editDateTime)[0:4]
        art.editDateTime = str(art.editDateTime)[5:10]
        art.authorID = username
        if year in my_article_year_list.keys():
            my_article_year_list[year].append(art)
        else:
            my_article_year_list[year] = [art]

    my_bug_list = Bugs.objects.filter(owner=username).order_by('-datetime')
    my_cve_year_list = {}
    for cve in my_bug_list:
        year = str(cve.datetime)[0:4]
        cve.datetime = str(cve.datetime)[5:10]
        print(cve.datetime)
        if year in my_cve_year_list.keys():
            my_cve_year_list[year].append(cve)
        else:
            my_cve_year_list[year] = [cve]
    context = {
        'user': usr,
        'publication_year_list': my_publication_year_list,
        'cve_year_list': my_cve_year_list,
        'article_year_list': my_article_year_list,
    }
    return render(request, 'hunter/user.html', context)


def detail(request, user_id):
    usr = get_object_or_404(User, pk=user_id)
    username = usr.name
    my_publication_year_list = {}
    pub_ids = PubToUser.objects.filter(username=username).all().values("pubID")
    for pub_id in pub_ids:
        pub = get_object_or_404(Publications, pk=pub_id['pubID'])
        year = str(pub.date)[0:4]
        pub.date = str(pub.date)[5:10]
        pub.link = pub.link.split('/')[-1]
        if year in my_publication_year_list.keys():
            my_publication_year_list[year].append(pub)
        else:
            my_publication_year_list[year] = [pub]

    my_bug_list = Bugs.objects.filter(owner=username).order_by('-datetime')
    my_cve_year_list = {}
    for cve in my_bug_list:
        year = str(cve.datetime)[0:4]
        cve.datetime = str(cve.datetime)[5:10]
        if year in my_cve_year_list.keys():
            my_cve_year_list[year].append(cve)
        else:
            my_cve_year_list[year] = [cve]
    context = {
        'user': usr,
        'publication_year_list': my_publication_year_list,
        'cve_year_list': my_cve_year_list,
    }
    return render(request, 'hunter/detail.html', context)


def article(request, article_id):
    art = get_object_or_404(Articles, pk=article_id)
    author = get_object_or_404(User, pk=art.authorID)
    art.author = author.name
    return render(request, 'hunter/article.html', {'article': art})


@csrf_exempt
def write_art(request):
    if request.is_ajax():
        username = request.POST.get('username', '')
        title = request.POST.get('title', '')
        content = request.POST.get('content', '')
        editdatetime = datetime.datetime.now().date()
        is_have_file = request.POST['isHaveFile']
        link=""
        # 加入判断题目是否相同
        is_have = Articles.objects.filter(title=title).count()
        if is_have > 0:
            return JsonResponse({'message': 0, 'error': '该题目已存在'})
        if int(is_have_file) > 0:
            myfile = request.FILES['myfile']
            if Articles.objects.filter(attachment=myfile.name).count():
                return JsonResponse({'message': 0, 'error': '文件已存在'})
            else:
                BASE_DIR = os.path.dirname(os.path.dirname(os.path.abspath(__file__)))
                destination = os.path.join(BASE_DIR, 'hunter', 'static', 'hunter/articles', myfile.name)
                if os.path.exists(destination):
                    os.remove(destination)
                with open(destination, 'wb+') as dest:
                    for chunk in myfile.chunks():
                        dest.write(chunk)
                    dest.close()
                link = myfile.name
        if Articles.objects.last() is None:
            articleID = 1
        else:
            articleID = Articles.objects.last().articleID + 1
        try:
            authorID = User.objects.get(name=username).userID
        except ObjectDoesNotExist as e:
            response = JsonResponse({"message": 0, 'error':'用户不存在，请检查是否登录'})
            return response
        try:
            Articles.objects.create(articleID=articleID, authorID=authorID, title=title, content=content,
                                    editDateTime=editdatetime,
                                    attachment=link)
            response = JsonResponse({"message": 1})
        except ProgrammingError as e:
            response = JsonResponse({"message": 0, 'error': '数据库错误'})
        return response
    return render(request, 'hunter/write.html')


@csrf_exempt
def uploadImg(request):
    file_obj = request.FILES.get("image")
    BASE_DIR = os.path.dirname(os.path.dirname(os.path.abspath(__file__)))
    file_path = os.path.join(BASE_DIR, 'hunter', 'static',  'hunter/articles/images', file_obj.name)
    link_path = os.path.join('/static', 'hunter/articles/images', file_obj.name)
    with open(file_path,'wb') as f:
        for chunk in file_obj.chunks():
            f.write(chunk)
    return HttpResponse(link_path)


@csrf_exempt
def delete_publication(request):
    pub_id = request.POST['pub_id']
    print(pub_id)
    try:
        PubToUser.objects.filter(pubID=pub_id).delete()
        Publications.objects.filter(pubID=pub_id).delete()
    except ObjectDoesNotExist as e:
        response = JsonResponse({"message": 0})
        return response
    response = JsonResponse({"message": 1})
    return response


@csrf_exempt
def delete_cve(request):
    cve_id = request.POST['cve_id']
    try:
        Bugs.objects.filter(identifier=cve_id).delete()
        response = JsonResponse({"message": 1})
        return response
    except ProgrammingError as e:
        response = JsonResponse({"message": 0})
        return response


@csrf_exempt
def delete_article(request):
    article_id = request.POST['article_id']
    try:
        Articles.objects.filter(articleID=article_id).delete()
        response = JsonResponse({"message": 1})
        return response
    except ProgrammingError as e:
        response = JsonResponse({"message": 0})
        return response


@csrf_exempt
def add_publication(request):
    title = request.POST['title']
    print(title)
    authors = request.POST['authors']
    uploadby = request.POST['username']
    myfile = request.FILES['myfile']
    print(authors)
    s='，'
    authors = authors.replace(s, ',')
    print(authors)
    journalname = request.POST.get('journalname')
    date = request.POST.get('date')
    print(date)
    index = request.POST.get('index')
    if Publications.objects.filter(title=title).count() > 0:
        return JsonResponse({'message': 0, "error": "该标题已存在"})
    if Publications.objects.last() is None:
        pubID = 1
    else:
        pubID = Publications.objects.last().pubID+1
        BASE_DIR = os.path.dirname(os.path.dirname(os.path.abspath(__file__)))
        destination = os.path.join(BASE_DIR,'hunter', 'static', 'hunter/publications', myfile.name)
        if os.path.exists(destination):
            os.remove(destination)
        with open(destination,'wb+') as dest:
            for chunk in myfile.chunks():
                dest.write(chunk)
            dest.close()
            link = myfile.name
            try:
                Publications.objects.create(pubID=pubID, title=title,link=link, messages='kidding', authors = authors,journalname=journalname,uploadByUser=uploadby,date=date,)
            except ProgrammingError as e:
                return JsonResponse({"message": 0})
            authorArr = authors.split(',')
            print(authorArr)
            for author in authorArr:
                try:
                    PubToUser.objects.create(pubID = pubID,username=author)
                    response = JsonResponse({"message": 1, 'pubID':pubID})
                except ProgrammingError as e:
                    return JsonResponse({"message": 0})
            # message["warning"] = "上传成功"
            # return HttpResponse(json.dumps(message), content_type='application/json')
    return response


@csrf_exempt
def add_cve(request):
    owner = request.POST['owner']
    bugType = request.POST['bugType']
    identifier = request.POST['cve_id']
    datetime = request.POST['date']
    software = request.POST['software']
    url = request.POST['url']
    if Bugs.objects.filter(identifier=identifier).count() > 0:
        return JsonResponse({'message': 0, "error": "该CVE已存在"})
    try:
        Bugs.objects.create(owner=owner, bugType=bugType, identifier=identifier, datetime=datetime,
                            software=software, url=url)
        response = JsonResponse({"message": 1})
        return response
    except ProgrammingError as e:
        response = JsonResponse({"message": 0})
        return response


@csrf_exempt
def add_article(request):
    return 0
